package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.transition.Explode;
import android.transition.Fade;
import android.view.View;
import android.view.animation.DecelerateInterpolator;
import android.widget.ImageView;
import android.widget.Toast;

public class Controles extends AppCompatActivity {

    private int id, defaultValue= 0, pantalla, instruct;
    private ImageView bBack, xBack, obstaculos, altura, direccion, bateria, bloquear, ayuda, conexion, velocidad;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_controles);


        //Rep dos valors. Pantalla és un valor que varia segons si es ve de Monta, Apren o directament de Vola
        //El id indica des de quin projecte (dins de l'apartat Monta), ve l'usuari
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);
        pantalla = i.getIntExtra("pantalla", defaultValue);
        instruct = i.getIntExtra("instruct", defaultValue);

        //Associació de variables a elements xml
        bBack = findViewById(R.id.bBackControles);
        xBack = findViewById(R.id.xBack);
        obstaculos = findViewById(R.id.cartelObst);
        altura = findViewById(R.id.cartelAltura);
        direccion = findViewById(R.id.cartelDirec);
        bateria = findViewById(R.id.cartelBateria);
        bloquear = findViewById(R.id.cartelBlock);
        ayuda = findViewById(R.id.cartelAyuda);
        conexion = findViewById(R.id.cartelConexion);
        velocidad = findViewById(R.id.cartelVel);


        //Desactivació d'elements, que s'activaràn en apretar el botó d'informació
        bBack.setElevation(2);
        xBack.setAlpha(0f);
        xBack.setEnabled(false);
        obstaculos.setAlpha(0f);
        altura.setAlpha(0f);
        direccion.setAlpha(0f);
        bateria.setAlpha(0f);
        bloquear.setAlpha(0f);
        ayuda.setAlpha(0f);
        conexion.setAlpha(0f);
        velocidad.setAlpha(0f);

        Toast.makeText(Controles.this, "instruct:" + instruct, Toast.LENGTH_LONG).show();
    }

    //Mètode per establir a quina pàgina es torna quan se ix de la pantalla de Controls
    public void volverControles (View v){
        //Si ve de Vola, torna al Menú principal
        if(pantalla == 0){
            Intent intentVolverControles = new Intent(Controles.this, MainActivity.class);
            startActivity(intentVolverControles);
        }
        //Si ve de Monta, torna a la pantalla explicatòria del projecte corresponent
        else if (pantalla ==1){
            switch (id){
                case 0:
                    if(instruct==1){
                        Intent intentVolverMonta1 = new Intent(Controles.this, IntroProyectos.class);
                        startActivity(intentVolverMonta1);
                }
                    else{
                    Intent intentVolverMonta = new Intent(Controles.this, PuntosConseguidos.class);
                    intentVolverMonta.putExtra("id", id);
                    startActivity(intentVolverMonta);
                }
                    break;
                case 1:
                    break;
            }
        }
        //Si ve d'Aprèn, torna al menú d'Aprèn
        else if (pantalla == 2){
            Intent intentVolverApren = new Intent(Controles.this, Apren.class);
            startActivity(intentVolverApren);
        }
    }

    //Mètode per a mostrar les instruccions
    public void infoVuelo(View v){
        bBack.setEnabled(false);
        bBack.setAlpha(0f);
        xBack.setEnabled(true);
        xBack.setAlpha(1f);
        xBack.setElevation(2);
        obstaculos.setAlpha(1f);
        altura.setAlpha(1f);
        direccion.setAlpha(1f);
        bateria.setAlpha(1f);
        bloquear.setAlpha(1f);
        ayuda.setAlpha(1f);
        conexion.setAlpha(1f);
        velocidad.setAlpha(1f);
    }

    //Mètode per ocultar les instruccions
    public void infoVueloVolver(View v){
        bBack.setEnabled(true);
        bBack.setAlpha(1f);
        bBack.setElevation(2);
        xBack.setEnabled(false);
        xBack.setAlpha(0f);
        xBack.setElevation(0);
        obstaculos.setAlpha(0f);
        altura.setAlpha(0f);
        direccion.setAlpha(0f);
        bateria.setAlpha(0f);
        bloquear.setAlpha(0f);
        ayuda.setAlpha(0f);
        conexion.setAlpha(0f);
        velocidad.setAlpha(0f);
    }

    //Mètode per tornar a la página anterior
    public void volver (View v){
        onBackPressed();
    }


}
