package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;
import androidx.constraintlayout.widget.ConstraintLayout;

import android.content.Intent;
import android.os.Bundle;
import android.transition.Explode;
import android.transition.Slide;
import android.view.Gravity;
import android.view.View;
import android.view.animation.AnimationUtils;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.LayoutAnimationController;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class IntroLeccion extends AppCompatActivity {

    private TextView numeroIntro, tituloIntro, preguntaIntro;
    private String numeroIntroRec, tituloIntroRec, preguntaIntroRec;
    private int id;
    private int defaultValue = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_intro_leccion);

        //Transició d'entrada
        Explode enterTransition =  new Explode();
        enterTransition.setDuration(500);
        enterTransition.setInterpolator(new DecelerateInterpolator());
        getWindow().setEnterTransition(enterTransition);

        //Assignació de variables a elements xml
        numeroIntro = findViewById(R.id.numeroLeccion);
        tituloIntro = findViewById(R.id.nombreLeccion);
        preguntaIntro = findViewById(R.id.preguntaLeccion);

        //Intent que permet recuperar el número, el títol, la pregunta i el id de la lliçó seleccionada
        Intent i = getIntent();
        numeroIntroRec = i.getStringExtra("numeroLeccion");
        tituloIntroRec = i.getStringExtra("tituloLeccion");
        preguntaIntroRec = i.getStringExtra("pregunta");
        id = i.getIntExtra("id", defaultValue);

        //Assignació dels valors recuperats a les variables associades a elements xml
        numeroIntro.setText(numeroIntroRec);
        tituloIntro.setText(tituloIntroRec);
        preguntaIntro.setText(preguntaIntroRec);
    }

    //Mètode que permet passar a la pantalla d'explicació
    public void instruccionesAprende(View v){
        Intent intentInstructA = new Intent(IntroLeccion.this, LeccionAprende.class);
        intentInstructA.putExtra("id", id);
        startActivity(intentInstructA);
        overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(IntroLeccion.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode per tornar a la pantalla anterior
    public void volver (View v){
        onBackPressed();

    }

    //Mètode que s'executa quan acaba l'activity i es passa a una altra
    @Override
    public void finish() {
        super.finish();
        overridePendingTransition(R.anim.slide_in_left, R.anim.slide_out_right);
    }
}
