package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.transition.Explode;
import android.view.View;
import android.view.animation.DecelerateInterpolator;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class IntroProyectos extends AppCompatActivity {

    private int id, instruct, defaultValue = 0, width;
    private TextView tituloIntro, preguntaProyectos, aviso;
    private LinearLayout laypotProyecto;
    private ImageView imgIntro;
    private String tituloIntroRec;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_intro_proyectos);

        //Assignació de variables a elements xml
        tituloIntro = findViewById(R.id.titProyecto);
        preguntaProyectos = findViewById(R.id.preguntaProyecto);
        laypotProyecto = findViewById(R.id.layoutProyecto);
        imgIntro = findViewById(R.id.imgIntroPtoyecto);
        aviso = findViewById(R.id.avisoProyectos);
        aviso.setAlpha(0f);

        //Intent que recupera el id i el títol enviats en la pantalla Montar.java
        Intent i = getIntent();
        id = i.getIntExtra("id", defaultValue);
        tituloIntroRec = i.getStringExtra("titulo");

        //S'assigna el títol recuperat a la variable per al títol
        tituloIntro.setText(tituloIntroRec);

        //Obtenció del tamany de pantalla guardat en activar la SplashScreen
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(IntroProyectos.this);
        width = prefs.getInt("width", 0);

        switch (id){

            case 0:
                preguntaProyectos.setText(R.string.pregunta_proyecto0);
                break;

            case 1:
            case 2:
                laypotProyecto.setAlpha(0f);
                laypotProyecto.setEnabled(false);
                aviso.setAlpha(1f);
                imgIntro.setImageResource(R.drawable.monta_3);
                imgIntro.getLayoutParams().height = 550;
                imgIntro.getLayoutParams().width = 670;
                imgIntro.setX(90);

                if(width>2000){
                    imgIntro.getLayoutParams().height = 740;
                    imgIntro.getLayoutParams().width = 800;
                    imgIntro.setX(110);
                }

                break;
        }
    }

    //Mètode onClick que assigna un valor per a la variable instruct diferent a cada element i permet passar a la pantalla següent
    public void selectPasoProyecto(View view){

        //Assignació de instruct
        switch (view.getId()){
            case R.id.layoutSkiron1:
                instruct = 1;
                break;

            case R.id.layoutSkiron2:
                instruct = 2;
                break;

            case R.id.layoutSkiron3:
                instruct = 3;
                break;

            case R.id.layoutSkiron4:
                instruct = 4;
                break;
        }

        //Intent per canviar de pantalla. Es passen el id i el número de la instrucció
        Intent intentIntroMontaje = new Intent(IntroProyectos.this, InstructPiezas.class);
        intentIntroMontaje.putExtra("id", id);
        intentIntroMontaje.putExtra("instruct", instruct);
        startActivity(intentIntroMontaje);
        overridePendingTransition(R.anim.slide_in_right, R.anim.slide_out_left);
    }

    //Mètode per tornar al menú principal
    public void menu (View v){
        Intent menu = new Intent(IntroProyectos.this, MainActivity.class);
        startActivity(menu);
    }

    //Mètode per tornar a la pantalla anterior
    public void volver (View v){
        onBackPressed();
    }
}
