package com.example.animoi;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

public class PopUpUsuario extends Activity {

    private EditText nombre;
    private int user= 0;
    private ImageView icon1, icon2, icon3, icon4, icon5, icon6;
    private int id=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pop_up_usuario);

        //Associació de variables als elements xml
        nombre = findViewById(R.id.etNombreUsuario);
        icon1 = findViewById(R.id.icon1);
        icon2 = findViewById(R.id.icon2);
        icon3 = findViewById(R.id.icon3);
        icon4 = findViewById(R.id.icon4);
        icon5 = findViewById(R.id.icon5);
        icon6 = findViewById(R.id.icon6);

        //Obtenció del tamany de pantalla del dispositiu
        DisplayMetrics dm = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(dm);

        //Associació de variables als valors anteriors
        int width = dm.widthPixels;
        int height = dm.heightPixels;

        //Creació del menú popUp segons les proporcions de la pantalla
        getWindow().setLayout((int)(width*.9), (int)(height*.85));
        if(width>2000){
            getWindow().setLayout((int)(width*.85), (int)(height*.8));
        }

        //Col·locació del menú popUp
        WindowManager.LayoutParams params = getWindow().getAttributes();
        params.gravity = Gravity.CENTER;
        params.x = -50;
        params.y = 20;
        getWindow().setAttributes(params);

        //Col·locació del menú popUp a la tableta
        if(width>2000){
            params.x = 0;
            params.y = -50;
            getWindow().setAttributes(params);
        }

        //Creació i emmagatzematge de la variable popUp per tal de saber si el menú ja ha apergut o no
        //Aquest menú sols ha d'aparèixer la primera vegada que l'usuari entre a l'aplicació
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(PopUpUsuario.this);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putInt("popUp", user);
        editor.apply();

    }

    //Mètode que permet seleccionar una icona i associa un número a cada una
    //La icona seleccionada obté un valor de transparència diferent a les altres icones
    public void selectIcono (View view){
        switch (view.getId()){
            case R.id.icon1:
               id=1;
               icon1.setAlpha(0.6f);
               icon2.setAlpha(1f);
               icon3.setAlpha(1f);
               icon4.setAlpha(1f);
               icon5.setAlpha(1f);
               icon6.setAlpha(1f);
               break;
            case R.id.icon2:
                id=2;
                icon2.setAlpha(0.6f);
                icon1.setAlpha(1f);
                icon3.setAlpha(1f);
                icon4.setAlpha(1f);
                icon5.setAlpha(1f);
                icon6.setAlpha(1f);
                break;
            case R.id.icon3:
                id=3;
                icon3.setAlpha(0.6f);
                icon2.setAlpha(1f);
                icon1.setAlpha(1f);
                icon4.setAlpha(1f);
                icon5.setAlpha(1f);
                icon6.setAlpha(1f);
                break;
            case R.id.icon4:
                id=4;
                icon4.setAlpha(0.6f);
                icon2.setAlpha(1f);
                icon3.setAlpha(1f);
                icon1.setAlpha(1f);
                icon5.setAlpha(1f);
                icon6.setAlpha(1f);
                break;
            case R.id.icon5:
                id=5;
                icon5.setAlpha(0.6f);
                icon2.setAlpha(1f);
                icon3.setAlpha(1f);
                icon4.setAlpha(1f);
                icon1.setAlpha(1f);
                icon6.setAlpha(1f);
                break;
            case R.id.icon6:
                id=6;
                icon6.setAlpha(0.6f);
                icon2.setAlpha(1f);
                icon3.setAlpha(1f);
                icon4.setAlpha(1f);
                icon5.setAlpha(1f);
                icon1.setAlpha(1f);
                break;
        }
    }

    //Mètode que guarda el nom i la icona seleccionades per l'usuari
    public void nombreUsuario (View v){
        //Obtenció dels valors seleccionats
        user = 1;
        String name;
        name = nombre.getText().toString();

        //Guardat dels valors. També es guarda la variable popUp. Com ja s'han plenat les dades, no tornarà a eixir el menú
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(PopUpUsuario.this);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString("user", name);
        editor.putInt("popUp", user);
        editor.putInt("icono", id);
        editor.apply();

        //Si l'usuari no ha seleccionat una icona no es pot eixir de la pantalla. I apareix un missatge emergent
       if(id>0) {
           Intent mainActivity = new Intent(this, MainActivity.class);
           startActivity(mainActivity);
       }else {
           Toast.makeText(PopUpUsuario.this, "Escoge un icono", Toast.LENGTH_LONG).show();
       }
    }
}
