package com.example.animoi;

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.viewpager.widget.PagerAdapter;

import com.airbnb.lottie.LottieAnimationView;

import java.util.List;

public class SliderAdapterApren extends PagerAdapter {

    public List<ItemExplicacion> explicaciones;
    private LayoutInflater layoutInflater;
    private Context context;

    //Mètode constructor
    public SliderAdapterApren(List<ItemExplicacion> explicaciones, Context context) {
        this.explicaciones = explicaciones;
        this.context = context;
    }

    //Mètode que obté el "tamany" del slider
    @Override
    public int getCount() {
        return explicaciones.size();
    }

    @Override
    public boolean isViewFromObject(@NonNull View view, @NonNull Object object) {
        return view.equals(object);
    }

    @NonNull
    @Override
    public Object instantiateItem(@NonNull ViewGroup container, int position) {
        layoutInflater = (LayoutInflater) context.getSystemService(context.LAYOUT_INFLATER_SERVICE);
        View view = layoutInflater.inflate(R.layout.layout_item_explicacion, container, false);

        //Assignació de variables a elements xml
        LottieAnimationView imgExplic = view.findViewById(R.id.imgExplicacion);
        TextView titExplic = view.findViewById(R.id.txTituloSlide);
        TextView txtExplic = view.findViewById(R.id.txExplicacion);

        //Assignació de valors a les variables anterior segons la posició del slider
        imgExplic.setAnimation(explicaciones.get(position).getImgInstruccion());
        titExplic.setText(explicaciones.get(position).getTitleInstruccion());
        txtExplic.setText(explicaciones.get(position).getTextInstruccion());

        container.addView(view, 0);

        return view;
    }

    @Override
    public void destroyItem(@NonNull ViewGroup container, int position, @NonNull Object object) {
        container.removeView((View)object);
    }
}
