package com.example.animoi;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class Usuario extends AppCompatActivity implements AdapterView.OnItemSelectedListener {

    private ImageView iconoUsuario, estrella, project1, project2, project3;
    private EditText nombreUsuario;
    private TextView txAjustes, txTamano, txVista, txProyectos, txPuntuacion;
    private LinearLayout lyAjustes;
    private String nombre;
    int id, pos1, pos2, pos1Rec, pos2Rec;
    private Spinner spinner1, spinner2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_usuario);

        //Assignació de variables a elements xml
        iconoUsuario = findViewById(R.id.iconUser);
        nombreUsuario = findViewById(R.id.nameUser);
        spinner1 = findViewById(R.id.spinnerTamano);
        spinner2 = findViewById(R.id.spinnerDalt);
        txAjustes = findViewById(R.id.txtAjustes);
        txTamano = findViewById(R.id.txtTamano);
        txVista = findViewById(R.id.txtVista);
        txProyectos = findViewById(R.id.proyectosPubli);
        txPuntuacion = findViewById(R.id.puntuacion);
        estrella = findViewById(R.id.estrellaPuntos);
        project1 = findViewById(R.id.proyecto1);
        project2 = findViewById(R.id.proyecto2);
        project3 = findViewById(R.id.proyecto3);
        lyAjustes = findViewById(R.id.layoutAjustes);

        //Es defineix com és el spinner i s'uneix als valors del array string (que conté els textos)
        ArrayAdapter<CharSequence> adapter1 = ArrayAdapter.createFromResource(this, R.array.spinner1, R.layout.spinner_item);
        adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner1.setAdapter(adapter1);
        spinner1.setOnItemSelectedListener(this);

        //Es defineix com és el spinner i s'uneix als valors del array string (que conté els textos)
        ArrayAdapter<CharSequence> adapter2 = ArrayAdapter.createFromResource(this, R.array.spinner2, R.layout.spinner_item);
        adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner2.setAdapter(adapter2);
        spinner2.setOnItemSelectedListener(this);

        //S'obtè el id i el nom de l'usuari guardat durant el registre inicial
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(Usuario.this);
        id = prefs.getInt("icono", 0);
        nombre = prefs.getString("user", "DEFAULT");

        //Segons el id guardat, es mostrarà una icona o altra, corresponent a la icona seleccionada per l'usuari
        nombreUsuario.setText(nombre);
        switch (id){
            case 1:
                iconoUsuario.setImageResource(R.drawable.icono1);
                break;
            case 2:
                iconoUsuario.setImageResource(R.drawable.icono2);
                break;
            case 3:
                iconoUsuario.setImageResource(R.drawable.icono3);
                break;
            case 4:
                iconoUsuario.setImageResource(R.drawable.icono4);
                break;
            case 5:
                iconoUsuario.setImageResource(R.drawable.icono5);
                break;
            case 6:
                iconoUsuario.setImageResource(R.drawable.icono6);
                break;
        }

        //S'obtè la selecció de les opcions dels spinners que ha fet l'usuari
        pos1Rec = prefs.getInt("pos1", 0);
        pos2Rec = prefs.getInt("pos2", 0);

        switch (pos1Rec) {
            case 0:
                spinner1.setSelection(0);
                break;

            case 1:
                spinner1.setSelection(1);
                break;

            case 2:
                spinner1.setSelection(2);
                break;

            case 3:
                spinner1.setSelection(3);
                break;
        }

        switch (pos2Rec) {
            case 0:
                spinner2.setSelection(0);
                break;

            case 1:
                spinner2.setSelection(1);
                break;

            case 2:
                spinner2.setSelection(2);
                break;
            case 3:
                spinner2.setSelection(3);
                break;
        }
    }

    //Mètode que guarda els cambis duta a terme per l'usuari en cas que vuiga caviar el nom
    //Retorna al menú principal
    public void guardarCambios (View view){
        String name;
        name = nombreUsuario.getText().toString();

        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(Usuario.this);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString("user", name);
        editor.putInt("pos1", pos1);
        editor.putInt("pos2", pos2);
        editor.apply();

        Intent intentMain = new Intent(Usuario.this, MainActivity.class);
        startActivity(intentMain);
    }

    //Mètode per tonrar a la pàgina anterior
    public void volver (View v){
        onBackPressed();
    }


    //Mètode que permet detectar quin item s'ha selecciona
    //Realitza els canvis necessaris segons l'element seleciconat
    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        spinner1.getItemAtPosition(position);
        spinner2.getItemAtPosition(position);

        //Canvis segons el que es seleccione al spinner 1
        if(parent.getId() == R.id.spinnerTamano) {
            switch (position) {
                case 0:
                    txVista.setTextSize(16);
                    txTamano.setTextSize(16);
                    txPuntuacion.setTextSize(16);
                    txProyectos.setTextSize(16);
                    txAjustes.setTextSize(16);
                    nombreUsuario.setTextSize(16);
                    pos1= 0;
                    break;

                case 1:
                    txVista.setTextSize(12);
                    txTamano.setTextSize(12);
                    txPuntuacion.setTextSize(12);
                    txProyectos.setTextSize(12);
                    txAjustes.setTextSize(12);
                    nombreUsuario.setTextSize(12);
                    pos1= 1;
                    break;

                case 2:
                    txVista.setTextSize(20);
                    txTamano.setTextSize(20);
                    txPuntuacion.setTextSize(20);
                    txProyectos.setTextSize(20);
                    txAjustes.setTextSize(20);
                    nombreUsuario.setTextSize(20);
                    pos1= 2;
                    break;

                case 3:
                    txVista.setTextSize(24);
                    txTamano.setTextSize(24);
                    txPuntuacion.setTextSize(24);
                    txProyectos.setTextSize(24);
                    txAjustes.setTextSize(24);
                    nombreUsuario.setTextSize(24);
                    pos1= 2;
                    break;
            }
        }

        //Canvis segons el que es seleccione al spinner 2
        if(parent.getId() == R.id.spinnerDalt) {
            switch (position) {
                case 0:
                    iconoUsuario.setImageResource(R.drawable.icono1);
                    txAjustes.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    txTamano.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    txVista.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    txProyectos.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    txPuntuacion.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    nombreUsuario.setTextColor(getResources().getColor(R.color.colorPaleta1));
                    estrella.setImageResource(R.drawable.estrella);
                    project1.setImageResource(R.drawable.proyecto);
                    project2.setImageResource(R.drawable.proyecto);
                    project3.setImageResource(R.drawable.proyecto);
                    lyAjustes.setBackgroundColor(getResources().getColor(R.color.colorPaleta2));
                    pos2= 0;
                    break;

                case 1:
                    iconoUsuario.setImageResource(R.drawable.protanopia);
                    txAjustes.setTextColor(getResources().getColor(R.color.protanopia1));
                    txTamano.setTextColor(getResources().getColor(R.color.protanopia1));
                    txVista.setTextColor(getResources().getColor(R.color.protanopia1));
                    txProyectos.setTextColor(getResources().getColor(R.color.protanopia1));
                    txPuntuacion.setTextColor(getResources().getColor(R.color.protanopia1));
                    nombreUsuario.setTextColor(getResources().getColor(R.color.protanopia1));
                    estrella.setImageResource(R.drawable.estrella_protanopia);
                    project1.setImageResource(R.drawable.proyecto_protanopia);
                    project2.setImageResource(R.drawable.proyecto_protanopia);
                    project3.setImageResource(R.drawable.proyecto_protanopia);
                    lyAjustes.setBackgroundColor(getResources().getColor(R.color.protanopia2));
                    pos2= 1;
                    break;

                case 2:
                    iconoUsuario.setImageResource(R.drawable.trinatopia);
                    txAjustes.setTextColor(getResources().getColor(R.color.white));
                    txTamano.setTextColor(getResources().getColor(R.color.trinatopia1));
                    txVista.setTextColor(getResources().getColor(R.color.trinatopia1));
                    txProyectos.setTextColor(getResources().getColor(R.color.trinatopia1));
                    txPuntuacion.setTextColor(getResources().getColor(R.color.trinatopia1));
                    nombreUsuario.setTextColor(getResources().getColor(R.color.trinatopia1));
                    estrella.setImageResource(R.drawable.estrella_trinatopia);
                    project1.setImageResource(R.drawable.proyecto_trinatopia);
                    project2.setImageResource(R.drawable.proyecto_trinatopia);
                    project3.setImageResource(R.drawable.proyecto_trinatopia);
                    lyAjustes.setBackgroundColor(getResources().getColor(R.color.trinatopia2));
                    pos2= 2;
                    break;

                case 3:
                    iconoUsuario.setImageResource(R.drawable.deuteranopia);
                    txAjustes.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    txTamano.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    txVista.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    txProyectos.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    txPuntuacion.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    nombreUsuario.setTextColor(getResources().getColor(R.color.deuteranopia1));
                    estrella.setImageResource(R.drawable.estrella_protanopia);
                    project1.setImageResource(R.drawable.proyecto_deuteranopia);
                    project2.setImageResource(R.drawable.proyecto_deuteranopia);
                    project3.setImageResource(R.drawable.proyecto_deuteranopia);
                    lyAjustes.setBackgroundColor(getResources().getColor(R.color.deuteranopia2));
                    pos2= 3;
                    break;
            }
        }
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {

    }
}
